dnl --------------------=|=--- i386/vp.m4 ---=|=-----------------------------
dnl --=-- The i386 implementation of the LLL virtual processor "kernel" --=--
dnl
dnl --- See ~moose/info/i386impl.nfo for more info about this. ---
dnl
dnl
Provide({vp},{
Require({video})
dnl
dnl

pmpart

__codeseg__({




dnl ----- Rebooting -----
; I was told from Ralph Brown's Interrupt List:
;
; Word [0040:0072] contains a flag for what to do after reboot:
; 1234 Warm Reboot (no memory test/CRT init)
; 4321 Preserve memory [PS/2 MCA only ?]
; 5678 System Suspend
; 9ABC Manufacturer Test
; ABCD Convertible POST loop
; 0064 Burn-in mode
; ???? many other values are used at POST
;
; Double Word [0040:0067] contaisn the real-mode point to jump into
; after some reboots ("Burn-in mode" ?)


Pseudo_Boot:
	clr(eax)
	mov al,#0x64
	jmp Reboot
Cold_Reboot:
	clr(eax)
	jmp Reboot
Warm_Reboot:
	mov ax,#0x1234
Reboot:
	cli
	push #ALLMEMDS
	pop fs
	seg fs
	mov [0x472],ax
	seg fs
	mov [0x467],edx

  ;; I was told that:
	mov ax, #0x50f                ;shutdown
	out #0x70, al                 ;write to CMOS
DoReboot:
	cli
__WaitOutReady:		; Busy-wait until 8042 is ready for new command
	in al,#0x64	; read 8042 status byte
	test al,2	; Bit 1 of status indicates input buffer full
	jnz __WaitOutReady
	mov al,#0xFE	; Pulse "reset" = 8042 pin 0
	out #0x64,al
	___die___	; It takes some time to reboot, so let's wait a bit.



dnl
dnl
dnl ----- Multithreading -----
dnl

Pause:
   NOP ; RET if no pause, NOP if yes pause.
   jmp Yield

define({NOPCODE},0x90)dnl
define({RETCODE},0xC3)dnl
define({PauseYes},{movb [pmaddr(Pause)],NOPCODE})dnl
define({PauseNo}, {movb [pmaddr(Pause)],RETCODE})dnl


Yield:
; procedure to yield execution
;
;
   ret


dnl
dnl --- When we're ready, uncomment following line:
dnl --- 
Require({kernel})
dnl
dnl

})
dnl
dnl
})dnl ---------- end of vp.m4 ------------------
dnl
